/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// File: DAGManHelper.h
// Author: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
// Copyright (c) 2003 EU DataGrid.

// $Id: dagman_helper.h,v 1.1.2.1.4.2 2010/04/07 14:02:46 mcecchi Exp $

#ifndef GLITE_WMS_MANAGER_SERVER_DAGMANHELPER_H
#define GLITE_WMS_MANAGER_SERVER_DAGMANHELPER_H

#include "glite/wms/helper/HelperImpl.h"
#include "glite/wms/helper/exceptions.h"

namespace classad {
class ClassAd;
}

namespace glite {
namespace wms {
namespace manager {
namespace server {

class DAGManHelperError: public helper::HelperError
{
public:
  DAGManHelperError()
    : helper::HelperError("DAGManHelper")
  {
  }
  char const* what() const throw()
  {
    return "DAGManHelperError";
  }
};

class DAGManHelper: public helper::HelperImpl
{
public:
  std::string id() const;
  std::string output_file_suffix() const;
  classad::ClassAd* resolve(
    classad::ClassAd const* input_ad,
    boost::shared_ptr<std::string> jw_template
  ) const;
};

}}}} // glite::manager::wms::server


#endif

// Local Variables:
// mode: c++
// End:
