/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// File: filelist_utils.h
// Author: Francesco Giacomini

#ifndef GLITE_WMS_MANAGER_SERVER_FILELIST_UTILS_H
#define GLITE_WMS_MANAGER_SERVER_FILELIST_UTILS_H

#include <string>
#include <boost/shared_ptr.hpp>
#include "glite/wms/common/utilities/FLExtractor.h"

namespace glite {
namespace wms {
namespace manager {
namespace server {

typedef glite::wms::common::utilities::FLExtractor<std::string> extractor_type;
typedef boost::shared_ptr<extractor_type> ExtractorPtr;
typedef extractor_type::iterator extractor_iterator;
typedef std::vector<extractor_iterator> requests_type;

class FLCleanUp
{
  ExtractorPtr m_extractor;
  extractor_iterator m_it;

public:
  FLCleanUp(ExtractorPtr e, extractor_iterator i)
    : m_extractor(e), m_it(i)
  {
  }
  void operator()()
  {
    m_extractor->erase(m_it);
  }
};

}}}} // glite::wms::manager::server

#endif
