/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// File: writers.h
// Authors: Francesco Giacomini <Francesco.Giacomini@cnaf.infn.it>
//          Marco Cecchi <Marco.Cecchi@cnaf.infn.it>
// Copyright (c) 2002 EU DataGrid.

#ifndef GLITE_WMS_MANAGER_SERVER_WRITERS_H
#define GLITE_WMS_MANAGER_SERVER_WRITERS_H

#include <boost/shared_ptr.hpp>

#include "glite/wms/common/utilities/FileList.h"
#include "glite/wms/common/utilities/FileListLock.h"
#include "glite/wms/common/utilities/scope_guard.h"
#include "glite/wms/common/utilities/jobdir.h"

namespace utilities = glite::wms::common::utilities;

namespace glite {
namespace wms {
namespace manager {
namespace server {

struct FileListBlob
{
  utilities::FileList<std::string> fl;
  utilities::FileListMutex mx;

  FileListBlob(std::string const& file_name)
    : fl(file_name), mx(fl)
  { }
};

struct Writers {
  std::string output;
  boost::shared_ptr<FileListBlob> fl;
  boost::shared_ptr<utilities::JobDir> jd;
  Writers(std::string const& name)
    : output(name)
  { }
};


}}}} // glite::wms::manager::server

#endif
